# ps3.py
#
# UVA CS 1120 -- Problem Set 3 -- Limning L-System Fractals
from graphics import *

authors = [ "mst3k" ]   # List all partner UVA IDs here, including yours

# Question 2 - write your code to answer the question below
def is_forward(lcommand):
        # is_forward(lcommand) evaluates to True if lcommand is a forward
        # command (indicated by its first element being the 'F' tag)
        return False

def is_rotate(lcommand):
        return False

def is_offshoot(lcommand):
        return False

def get_angle(lcommand):
        # get_angle() evaluates to the angle associated with the rotate
        # command. Produces an error if the command is not a rotate command.
        if True:                # Replace "True" with your expression
                return 0        # Replace "0" with your expression
        else:
                # This next line produces an error and prints out the
                # message 'Not a rotate command'. We'll cover the Python
                # keyword "raise" later in class. For now it just means
                # "stop and signal an error". 
                raise RuntimeError('Not a rotate command') 

def get_offshoot_commands(lcommand):
        # get_offshoot_commands(lcommand) evaluates to the offshoot command
        # list associated with lcommand. You should produce an
        # error (as above) if lcommand is not an offshoot command.
        return []

# Once you have defined is_forward, is_rotate and is_offshot above,
# this is_lsystem_command will work perfectly with no changes. 
def is_lsystem_command(x):
    return is_forward(x) or is_rotate(x) or is_offshoot(x)

# Similarly, this is a correct implementation of flatten_commands, but
# it will only work if is_lsystem_command works.
def flatten_commands(ll):
    if len(ll) == 0:
        return ll
    elif is_lsystem_command(ll[0]):
        return [ll[0]] + flatten_commands(ll[1:])
    else:
        x = [flatten_commands(ll[0])] + flatten_commands(ll[1:])
        return x[0] + x[1:]

# Question 4 - write your code to answer the question below
def rewrite_lcommands(lcommands, replacement):
        return []

# Question 5 - write your code to answer the question below

# a. Define vertical_mid_line
def vertical_mid_line(t):
        return 0

# b. Define make_vertical_line
def make_vertical_line(y):
        return 0

# Question 6 - write your code to answer the question below

# Define half_line
def half_line(t):
        return 0

# Question 7 - write your code to answer the question below
# num_points(p, n)
# 	p is the number of t values left
#	n is the number of curves left
def num_points(p, n):
        if (n == 1):            # if there is one curve left
                return p        # it gets all of the remaining points
        else:                   # otherwise, the rest of the curves 
                return 0        # get half of the remaining points


# Question 8 and 9 - write your code to answer the question below
def convert_lcommands_to_curvelist(lcommands):
        if len(lcommands) == 0:
                # We need to make a leaf with just a single point of green
                green = (0,255,0) 
                return [lambda t:make_colored_point(0,0,green)]
        elif is_forward(lcommands[0]):
                # Make a vertical_line and then recurse on the rest of the
                # list
                return construct_simple_curvelist(vertical_line, \
                        convert_lcommands_to_curvelist(lcommands[1:]))
        elif is_rotate(lcommands[0]):
                # If this command is a rotate, every curve in the rest
                # of the list should be rotated by the rotate angle
                # Lsystem turns are clockwise, so we need to use - angle.
                rotate_angle = -1*get_angle(lcommands[0])
                # Question 8: fill in this part
                return []
        elif is_offshoot(lcommands[0]):
                # Question 9: fill in this part
                return []
        else:
                raise RuntimeError("Bad Command")

# Question 10 - write your code to answer the question below
def make_lsystem_fractal(replace_commands, start, level):
        return False

# Question 12: Remember that """ delimits a possibly-multi-line string.
ta_comments = """
My favorite TA is NAME because... 
"""

# PUT CODE TO TEST HERE:

def make_tree_fractal(level):
    return make_lsystem_fractal(tree_commands,
        make_lsystem_command(make_forward_command()),level)

# This draws a diagonal line from the lower-left to the upper-right: 
# window_draw_line(make_point(0.0, 0.0), make_point(1.0, 1.0))

def draw_lsystem_fractal(lcommands):
    draw_curve_points(
        position_curve(
            connect_curves_evenly(
                convert_lcommands_to_curvelist(lcommands))
            ,0.5,0.1),5000)

# draw_lsystem_fractal(make_tree_fractal(3))

# We'll save your last image as "fractal.svg". 
save_image("fractal.svg")       # To make our pretty graphics work, 
turtle.exitonclick()            # THESE MUST BE THE LAST LINES HERE!
